#pragma once

#include "solution.h"

#include <set>

typedef unsigned int entry_count_t;

class solution_comparator {
public:
    solution_comparator(const entry_count_t &ref_entry_count);
    bool operator()(const solution &arg1, const solution &arg2) const;
private:
    const entry_count_t &_ref_entry_count;
    solution_comparator(); // no default constructor
    // no assignment operator
    solution_comparator &operator =(const solution_comparator &);
};

class solution_set: public std::set<solution, solution_comparator> {
public:
    solution_set(); // default constructor
    entry_count_t get_entry_count() const;
    void set_entry_count(entry_count_t entry_count);
private:
    entry_count_t _entry_count;
};

class solve_progress_listener {
public:
    virtual void
    node_visited(span entry_array[], entry_count_t entry_count)
    = 0;
};

unsigned int
solve(
const std::multiset<span> &ref_in_val_list,
unsigned int max_solution_count,
unsigned int max_visited_node_count,
solve_progress_listener *pListener,
solution_set &ref_best_set,
unsigned long long &ref_elapsed_time
);
